﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Threading;

namespace BindingListDemoConsole
{
    public class CollectionManager
    {
        private static CollectionManager _Instance = null;
        private static BindingList<CollectionMember> _list = null;

        private int _count = 500;
        public int Count { get { return _count; } }

        public static CollectionManager Instance
        {
            get
            {
                if (_Instance == null)
                    _Instance = new CollectionManager();

                return _Instance;
            }
        }

        private CollectionManager()
        {
            _list = new BindingList<CollectionMember>();

            for (int i = 0; i < _count; i++)
            {
                //Thread.Sleep(5);
                _list.Add(new CollectionMember(i));
            }
        }

        public BindingList<CollectionMember> GetList()
        {
            return _list;
        }

        public void AddMember(Random r)
        {
            _list.Add(new CollectionMember(r.Next(0, _count)));
            _count++;
        }
    }
}
